﻿using Styx.Common;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Styx.Pathing;
using Styx.CommonBot.POI;
using Styx.CommonBot;
using Buddy.Coroutines;
using Styx.Common.Helpers;

namespace Seeker.Classes
{
    class WorkOrders : Common
    {
        private static WaitTimer Interacttimer = new WaitTimer(TimeSpan.FromSeconds(2));
        private static int currentqueued = Lua.GetReturnVal<int>("return C_Garrison.GetNumPendingShipments ()", 0);
        private static int maxqueued = 15;
        //private static string currencyname = Lua.GetReturnVal<string>("return C_Garrison.GetShipmentReagentInfo(1)", 0);
        //private static int currencyneeded = Lua.GetReturnVal<int>("return C_Garrison.GetShipmentReagentInfo(1)", 3);
        //private static int currencyhave = Lua.GetReturnVal<int>("return C_Garrison.GetShipmentReagentInfo(1)", 4);
        private static bool WindowOpen = false;
        public static void Init()
        {
            Lua.Events.AttachEvent("SHIPMENT_CRAFTER_OPENED", ShipmentCrafterOpenedEventHandler);
            Lua.Events.AttachEvent("SHIPMENT_CRAFTER_CLOSED", ShipmentCrafterClosedEventHandler);
            Lua.Events.AttachEvent("SHIPMENT_CRAFTER_INFO", ShipmentCrafterInfoEventHandler);
        }
        public static void UnInit()
        {
            Lua.Events.DetachEvent("SHIPMENT_CRAFTER_OPENED", ShipmentCrafterOpenedEventHandler);
            Lua.Events.DetachEvent("SHIPMENT_CRAFTER_CLOSED", ShipmentCrafterClosedEventHandler);
            Lua.Events.DetachEvent("SHIPMENT_CRAFTER_INFO", ShipmentCrafterInfoEventHandler);
        }
        public static void WorkOrderCheck()
        {
            if (BotPoi.Current.Type == PoiType.None && Settings.General.Instance.AutoTurnInWorkOrder)
            {
                WoWUnit ToInteract = WorkOrderNPC;
                if (ToInteract != null && ToInteract.IsValid)
                {
                    Logging.Write(name + ": Behaviour created to Interact with  " + ToInteract.SafeName);
                    BotPoi.Current = new BotPoi(ToInteract, PoiType.Interact);
                    return;
                }
            }

        }
        public static async Task<bool> DoWorkorder(WoWUnit ToInteract)
        {
            using (new PerformanceLogger(name + ": DoWorkorder"))
            {
                if (ToInteract != null && ToInteract.IsValid)
                {
                    WoWGuid TargetGuid = ToInteract.Guid;
                    if (await Interact(ToInteract))
                    {
                        //I have to assume that if we made it this far that looting is done, Remove it.
                        if (Settings.General.Instance.AdvancedLogging) Logging.Write(name + ":" + ToInteract.SafeName + " appears to be finished, removing from our list");
                        Blacklist.Add(TargetGuid, BlacklistFlags.All, TimeSpan.FromHours(4));
                        BotPoi.Clear("Interacting Finished");
                    }
                }
                return false;
            }
        }
        private static async Task<bool> Interact(WoWUnit ToInteract)
        {
            using (new PerformanceTimer(name + ": Interact"))
            {
                if (ToInteract == null)
                    return true;
                if (ToInteract != null)
                {
                    if (!Blacklist.Contains(ToInteract.Guid, BlacklistFlags.Loot) && await Movement.MoveToTargetRoutine(ToInteract))
                    {
                        if (ToInteract.Location.Distance(StyxWoW.Me.Location) <= ToInteract.InteractRange && !StyxWoW.Me.IsMoving)
                        {
                            Interacttimer.Reset();
                            ToInteract.Interact();
                            await Coroutine.Wait(5000, () => WindowOpen);
                            await Coroutine.Sleep(3000);
                            return true;
                        }
                    }
                }
                return false;
            }
        }
        private static void DoWork()
        {
            for (int i = maxqueued - currentqueued + 1; i >= 0; i--)
            {
                if (WindowOpen)
                    Lua.DoString("C_Garrison.RequestShipmentCreation ()");
            }
            Lua.DoString("C_Garrison.RequestShipmentInfo();");
            Logging.Write(name + " Work Orders Finished");
        }
        private static void ShipmentCrafterOpenedEventHandler(object sender, LuaEventArgs args)
        {
            WindowOpen = true;
            Lua.DoString("C_Garrison.RequestShipmentInfo();");
            DoWork();
        }
        private static void ShipmentCrafterClosedEventHandler(object sender, LuaEventArgs args)
        {
            WindowOpen = false;
        }
        private static void ShipmentCrafterInfoEventHandler(object sender, LuaEventArgs args)
        {
            maxqueued = (int)args.Args[2];
        }
        private static HashSet<int> WorkOrderGivers = new HashSet<int>()
        {
            84248, //Alliance LumberMill
            87214, //Alliance Trader
            77791, //Alliance Alchemist
            77778 //Alliance Tailoring
        };
        private static WoWUnit WorkOrderNPC
        {
            get
            {
                return ObjectManager.GetObjectsOfType<WoWUnit>().Where(o => IsValid(o)
                    && WorkOrderGivers.Any(g => o.Entry == g) && Navigator.CanNavigateFully(StyxWoW.Me.Location, o.Location)).
                    OrderBy(t=> t.Distance).FirstOrDefault();
            }
        }
    }
}
